<template>
  <div id="unit" class="flex-row">
    <div class="basic-main" @keyup.enter="search">
      <div class="flex" v-if="!show">
        <criteria-paged :model="model"  v-ref:paged>
          <criteria partial='criteria' @condition-changed='$parent.selfSearch' v-ref:cri>
            <div novalidate class="form-horizontal select-overspread container-fluid auto" partial >
              <div class="row">
                <div class="col-sm-2 form-group">
                  <label for="startDate" class="font_normal_body">开始日期</label>
                  <datepicker id="startDate" placeholder="开始日期" style="width:60%"
                              v-model="model.startDate"
                              :value.sync="model.startDate"
                              :format="'yyyy-MM-dd 00:00:00'"
                              :show-reset-button="true">
                  </datepicker>
                </div>
                <div class="col-sm-2 form-group">
                  <label for="endDate" class="font_normal_body">结束日期</label>
                  <datepicker id="endDate" placeholder="结束日期" style="width:60%"
                              v-model="model.endDate"
                              :value.sync="model.endDate"
                              :format="'yyyy-MM-dd 23:59:59'"
                              :show-reset-button="true">
                  </datepicker>
                </div>
                <res-select-group :initres="$parent.$parent.initres"  @re-res="$parent.$parent.getRes" v-ref:sel :show-component="$parent.$parent.showself"></res-select-group>
                <div class="col-sm-2 form-group">
                  <label class="font_normal_body">&nbsp;付款方式&nbsp;</label>
                  <v-select :value.sync="model.f_payment"
                            class="select_list select"
                            multiple
                            :search="false"
                            v-model="model.f_payment"
                            style="width: 60%"
                            :options='$parent.$parent.paytype'
                            placeholder='付款方式'
                            close-on-select>

                  </v-select>
                </div>
                <div class="col-sm-2 form-group">
                  <label class="font_normal_body">&nbsp;&nbsp;&nbsp;小区&nbsp;&nbsp;&nbsp;</label>
                  <v-select :value.sync="model.f_residential_area"
                            class="select_list select"
                            enter-push
                            multiple = "true"
                            v-model="model.f_residential_area"
                            style="width: 60%"
                            :options='$parent.$parent.residentialArea' placeholder='选择小区'
                            close-on-select>

                  </v-select>
                </div>
                <div class="span" style="float:right;">
                  <button class="button_search button_spacing" @click="search()">查询</button>
                  <button class="button_clear button_spacing" @click="$parent.$parent.clear()">清空</button>

                  <export-excel :data="$parent.$parent.getCondition"
                                :field="$parent.$parent.getfield"
                                :footer="$parent.$parent.footer"
                                :header="$parent.$parent.other"
                                sqlurl="api/af-revenue/logic/openapi/exportfile"
                                sql-name="chargeDayReport"
                                template-name='收费明细日报表导出'
                                :choose-col="true"></export-excel>
                  <print-data :model="$parent.model" :field="$parent.$parent.getfield"
                              :printview="false"
                              :xyprint="2"

                              :footinfo="['制表人','审核人']"
                              :defaultfield="$parent.$parent.defaultfield" print-name="收费明细"
                              :sumsmodel="$parent.$parent.sumsmodel" :sum-field="$parent.$parent.sumField"
                                :start-date="$parent.$parent.startDate" :end-date="$parent.$parent.endDate"
                  ></print-data>
                </div>
              </div>
              <div class="row" v-show="$parent.$parent.criteriaShow">

              </div>
            </div>
          </criteria>
          <data-grid :model="model" partial='list' class="list_area table_sy" v-ref:grid :classname="$parent.classname">
            <template partial='head'>
              <tr>
                <th>
                  <nobr>序号</nobr>
                </th>
                <th>
                  <nobr>收费编号</nobr>
                </th>
                <th>
                  <nobr>客户编号</nobr>
                </th>
                <th>
                  <nobr>户主名称</nobr>
                </th>
                <th>
                  <nobr>小区</nobr>
                </th>
                <th>
                  <nobr>客户地址</nobr>
                </th>
                <th>
                  <nobr>气量</nobr>
                </th>
                <th>
                  <nobr>收款</nobr>
                </th>
                <th>
                  <nobr>单价</nobr>
                </th>
                <th>
                  <nobr>付款方式</nobr>
                </th>
                <th>
                  <nobr>收费时间</nobr>
                </th>
                <th>
                  <nobr>收费员</nobr>
                </th>
                <th>
                  <nobr>收费类型</nobr>
                </th>
              </tr>
            </template>
            <template partial='body'>
              <td style="text-align:center">
                <nobr>{{row.ord}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.id}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_userinfo_code}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_user_name}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_residential_area}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_address}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_pregas}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_preamount}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.price}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_payment}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_date}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_operator}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.f_type}}</nobr>
              </td>
            </template>
            <template partial='foot'></template>
          </data-grid>
        </criteria-paged>
        <table class="table-hover">
          <tr style="position: relative" class="table-bordered">
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;color: #5CB95C;font-weight: bold" >
              报表统计时间
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold" v-if="startDate==endDate">
              {{startDate}}
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold" v-else>
              {{startDate+" 至 "+endDate}}
            </td>
          </tr>
          <tr style="position: relative" class="table-bordered">
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;color: #5CB95C;font-weight: bold">
              汇总信息
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              总气量:&emsp;{{sumsmodel.f_pregas}}
            </td>
            <td style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              总金额:&emsp;{{sumsmodel.f_preamount}}
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</template>
<script>
  import {PagedList, HttpResetClass} from 'vue-client'
  import defaultPrint from './config/DefaultPrint'
  import exportConfig from './config/exportConfig'
  // import PrintDataSelf from '../sale/common/PrintDataSelf'

  let readySomething = async function (self) {
    self.$refs.paged.$refs.cri.model.startDate = self.$login.toStandardDateString() + ' 00:00:00'
    self.$refs.paged.$refs.cri.model.endDate = self.$login.toStandardDateString() + ' 23:59:59'

    self.sumsmodel = self.$refs.paged.$refs.grid.model.sums
  }
  export default {
    title: '收费明细日报表',
    props: ['data'],
    data() {
      return {
        data: {},
        other:[],
        footer:[],
        model: new PagedList('api/af-revenue/sql/chargeDayReport', 20, {startDate: 'this.model.startDate', endDate: 'this.model.endDate'},{
          f_pregas:0,
          f_collection:0
        }),
        paytype: this.$appdata.getParam('付款方式'),
        gasproperties:[],
        initres: {
          org:[this.$login.f.orgid],
          dep:[],
          user:[],
        },
        showself:['company','department','operator'],
        show:false,
        rowdata:{},
        criteriaShow: false,
        residentialArea: [],
        area:[],
        pays:[],
        orgCondtionStr: '',
        modelval: [],
        startDate:"",
        endDate:"",
        inputtouPerson: [],
        printshow: false,
        all: false,
        fields: {},
        thead: '',
        tfoot: '',

        // 下拉框

        //合计数据
        sumsmodel: {},
        sumField: {
           'f_pregas': '方量', 'f_preamount': '金额'
        },
        pageSum: {
          'f_pregas': '0.00',
          'f_preamount': '0.00',
        },
        defaultfield: [],
        config: {
          defaultPrint: ['f_userinfo_code', 'f_user_name']
        },
        batchmoneyShow:false
      }
    },
    ready() {
      this.getaddress()
      readySomething(this).then(() => {
        this.$emit('ready')
      }).catch((error) => {
        this.$emit('error', error)
      })
    },
    methods: {
      getotherfooter(){
        // this.$refs.paged.$refs.cri.$refs.exports.otherData=[];
        // this.$refs.paged.$refs.cri.$refs.exports.footerData=[];
        this.other=[];
        this.footer=[];
        let exportdata = this.getCondition;
        let otherInData=[];
        otherInData.push(`导出时间: ${this.$login.toStandardTimeString()}`);
        let footerData=[],exportfield=this.getfield;
        footerData.push("合计");
        let self =this;
        for(var field in self.sumsmodel){
          footerData.push(`${exportfield[field]}合计:${self.sumsmodel[field]}`);
        }
        this.footer.push(footerData);
        this.other.push(otherInData);
      },
      search(){
        this.$refs.paged.$refs.cri.search()
      },
      selfSearch(args) {
        this.startDate=this.$refs.paged.$refs.cri.model.startDate.substring(0,10)
        this.endDate=this.$refs.paged.$refs.cri.model.endDate.substring(0,10)
        args.condition = `${args.condition} ` +' and '+this.orgCondtionStr.trim().substring(4)
        //小区查询条件
        this.area =  this.$refs.paged.$refs.cri.model.f_residential_area
        if(this.area.length !== 0){
          let str = JSON.stringify(this.area)
          str = str.replace(/"/g,`'`)
          str = str.replace(/\[/g,``)
          str = str.replace(/\]/g,``)
          //查询多个小区时条件
          args.condition += ` and f_residential_area in  ( ${str} )`
        }
        this.pays =  this.$refs.paged.$refs.cri.model.f_payment
        if(this.pays.length !== 0){
          let str = JSON.stringify(this.pays)
          str = str.replace(/"/g,`'`)
          str = str.replace(/\[/g,``)
          str = str.replace(/\]/g,``)
          //查询多种付款方式时条件
          args.condition += ` and f_payment in  ( ${str} )`
        }
        this.model.search(args.condition, args.model)
        this.sumsmodel = this.$refs.paged.$refs.grid.model.sums
      },
      clear() {
        //清空部门和人员
        this.$refs.paged.$refs.cri.$refs.sel.$children[1].selectres = []
        //部门和人员变为全选
        this.$refs.paged.$refs.cri.$refs.sel.$children[1].$children[0].isSelectAll = false
        this.$refs.paged.$refs.cri.$refs.sel.$children[2].$children[0].isSelectAll = false
        Object.keys(this.$refs.paged.$refs.cri.model).forEach((key) => {
          this.$refs.paged.$refs.cri.model[key] = []
        })
      },
      async  getaddress(){
        let HttpReset = new HttpResetClass()
        var data = await HttpReset.load('POST', 'api/af-revenue/sql/manage_getarealist', {
          data: {
            condition: `1=1 and s.f_orgid = '${this.$login.f.orgid}'`
          }
        }, {resolveMsg: null, rejectMsg: '获取小区失败!'})
        console.log('小区',data)
        let house = [{label: '全部', value: ''}]
        for (let row of data.data){
          house.push({label: row.f_residential_area, value: row.f_residential_area})
        }
        this.residentialArea = house
      },
      show() {
        this.criteriaShow = true
      },
      hidden() {
        this.criteriaShow = !this.criteriaShow
      },
      getRes(obj) {
        this.orgCondtionStr = obj
      },
      stamp() {
        this.all = false
        //默认选择要打印的列
        this.modelval = defaultPrint.config
        this.fields = this.getfield
        console.log('所有打印字段', this.fields)
        this.printshow = true
        this.put()
      },
      put() {
        // 对Modelval进行排序
        this.sortModelval()
        this.thead = `<tr><th colspan=${this.modelval.length}>收费查询统计报表</th></tr><tr>`
        for (let key of this.modelval) {
          this.thead += '<th>' + this.fields[key] + '</th>'
        }
        this.thead += '</tr>'
      },
      print() {
        this.$refs.print.PrintAsFile()
        this.printshow = false
      },
      dealmsg(val) {
        console.log('---------------dealmsg')
        this.rowdata=val
        this.show=true
        val.model = this.model.model
        this.$dispatch('deal-msg', val)
      },
      close() {
        this.printshow = false
        this.all = false
      },
      // 对选择的列进行排序
      sortModelval() {
        let sortModel = []
        Object.keys(this.fields).forEach((key) => {
          if (this.modelval.includes(key)) {
            sortModel.push(key)
          }
        })
        this.modelval = sortModel
        console.log('选择的打印的字段', this.modelval)
      },
      userTypeChange () {
        this.gasproperties=[]
        if(this.$refs.paged.$refs.criteria.model !==null) {
          this.$refs.paged.$refs.criteria.model.f_gasproperties=''
          this.gasproperties = this.$appdata.getParam(this.$refs.paged.$refs.criteria.model.f_user_type[0])
        }
        else{
          this.gasproperties =[{label: '全部', value: ''}]
        }
      },
    },
    watch: {
      'all'(val) {
        if (val) {
          this.modelval = this.bodyData
        } else {
          this.modelval = defaultPrint.config
          this.put()
        }
      },
      'modelval.length'() {
        this.put()
      },
      sumsmodel:{
        handler: function(val) {
          this.getotherfooter();
        },
        deep: true
      }
    },
    computed: {
      getCondition() {
        return {
          startDate: this.$refs.paged.$refs.cri.model.startDate,
          endDate: this.$refs.paged.$refs.cri.model.endDate,
          condition: this.$refs.paged.model.condition
        }
      },
      getfield() {
        return exportConfig.ChargeDayReportConfig
      },
      whetherpaies () {
        return [
          {label: '全部', value: ''},
          {label: '已缴费', value: '是'},
          {label: '未缴费', value: '否'}
        ]
      },
      usertypes() {
        return [{label: ' 全部 ', value: ''}, ...this.$appdata.getParam('用户类型')]
      }

    }
  }
</script>
